/*
mlp_nnn.hh

This C++ header file defines the NML Messages used for command and status by MLP_NN_MODULE
Template Version 1.1

MODIFICATIONS:
Thu Dec 21 12:37:02 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef MLP_NNN_HH
#define MLP_NNN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define NUM_OF_INPUTS 2
#define NUM_OF_OUTPUTS 2
#define NUM_OF_NEURONS 10


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define MLP_NN_STATUS_TYPE 1000
#define MLP_NN_HALT_TYPE 1001
#define MLP_NN_INIT_TYPE 1002
#define MLP_NN_RUN_TYPE 1003
#define MLP_NN_SET_ACTVATION_FUNCTION_TYPE_TYPE 1004
#define MLP_NN_SET_ADAPTATION_GAIN_TYPE 1005
#define MLP_NN_SET_INPUT_BIASES_TYPE 1006
#define MLP_NN_SET_INPUT_WEIGHTS_TYPE 1007
#define MLP_NN_SET_OUTPUT_BIASES_TYPE 1008
#define MLP_NN_SET_OUTPUT_WEIGHTS_TYPE 1009
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class MLP_NN_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	MLP_NN_STATUS();

	// Constructor used by derived classes
	MLP_NN_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  double adaptation_gain;
  int activation_function_type;
   
};

// Command Classes

class MLP_NN_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_SET_ACTVATION_FUNCTION_TYPE : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_ACTVATION_FUNCTION_TYPE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int activation_function_type;
};

class MLP_NN_SET_ADAPTATION_GAIN : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_ADAPTATION_GAIN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double eta;

};

class MLP_NN_SET_INPUT_BIASES : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_INPUT_BIASES();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double input_biases[NUM_OF_INPUTS];

};

class MLP_NN_SET_INPUT_WEIGHTS : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_INPUT_WEIGHTS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
    double input_weights[NUM_OF_NEURONS * NUM_OF_INPUTS];

};

class MLP_NN_SET_OUTPUT_BIASES : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_OUTPUT_BIASES();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double output_biases[NUM_OF_OUTPUTS];

};

class MLP_NN_SET_OUTPUT_WEIGHTS : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_SET_OUTPUT_WEIGHTS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
    double output_weights[NUM_OF_OUTPUTS * NUM_OF_NEURONS];

};

// Declare NML format function
extern int mlp_nnFormat(NMLTYPE, void *, CMS *);

#endif 	// MLP_NNN_HH
