/*
	mlp_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		MLP_NN_MODULE

	MODIFICATIONS:
	Thu Dec 21 12:37:03 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "mlp_nn.hh"	// definition of MLP_NN_MODULE

// flag signifying main loop is to terminate
int mlp_module_done = 0;

//signal handler for ^C
extern "C" void mlp_module_quit(int sig);
void mlp_module_quit(int sig)
{
	mlp_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int mlp_module_run();

int mlp_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	MLP_NN_MODULE *mlp_nn = new MLP_NN_MODULE();

	// set the SIGINT handler
	signal(SIGINT, mlp_module_quit);

	// enter main loop
	while(!mlp_module_done)
	{
		mlp_nn->controller();

		timer->wait();
	}

	// Delete Modules
	delete mlp_nn;

	// Delete Timer
	delete timer;
}

