/*
mlp_nn.cc

This C++ file defines member functions for the class MLP_NN_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Thu Dec 21 12:37:03 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "mlp_nn.hh" 	// MLP_NN_MODULE definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "mlp_nnn.hh" 	// NML Commands and Status definitions for mlp_nn
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
MLP_NN_MODULE::MLP_NN_MODULE(int _is_base_class)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
	if(!_is_base_class)
	{
		INITIALIZE_NML();
	}
	// Add additional code to initialize the module here.
        num_of_inputs = NUM_OF_INPUTS;
        num_of_outputs = NUM_OF_OUTPUTS;
        num_of_neurons = NUM_OF_NEURONS;

	mlp = new MLP(num_of_inputs, num_of_outputs, num_of_neurons);
        
        if(mlp->mlp_err != MLP_NO_ERROR)
          {
            logError("Error in creating MLP_NN_MODULE object!!!");
            status = RCS_ERROR; // let my supervisor know I have a problem.
          }

    if ((temp1 = new double*[num_of_neurons]) == NULL)
      {
        logError("Error in creating RBF_NN_MODULE object!!!");
        status = RCS_ERROR; // let my supervisor know I have a problem.
      }
    for (int ii = 0; ii < num_of_neurons; ii++)
      {
        if ((temp1[ii] = new double[num_of_inputs]) == NULL)
          {
            logError("Error in creating KALMAN_FILTER_MODULE object!!!");
            status = RCS_ERROR; // let my supervisor know I have a problem.
          }
      }

    if ((temp2 = new double*[num_of_outputs]) == NULL)
      {
        logError("Error in creating RBF_NN_MODULE object!!!");
        status = RCS_ERROR; // let my supervisor know I have a problem.
      }
    for (int ii = 0; ii < num_of_outputs; ii++)
      {
        if ((temp2[ii] = new double[num_of_neurons]) == NULL)
          {
            logError("Error in creating KALMAN_FILTER_MODULE object!!!");
            status = RCS_ERROR; // let my supervisor know I have a problem.
          }
      }

}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void MLP_NN_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "mlp_nn", "mlp_module.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(mlp_nnFormat, "mlp_nn_cmd", "mlp_nn", "mlp_module.nml"));
	mlp_nn_status = new MLP_NN_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(mlp_nnFormat, "mlp_nn_sts", "mlp_nn", "mlp_module.nml"), mlp_nn_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.
*/
void MLP_NN_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code
  // Read and/or calculate inputs to the MLP NN
  // Here we just assign them to zero

  // System inputs
  for(int ii = 0; ii < num_of_inputs; ii++)
    {
      sys_inputs[ii] = 0.0;
    }

  // Read and/or calculate the output errors 
  // Here we just assign them to zero
  for(int ii = 0; ii < num_of_outputs; ii++)
    {
      output_errors[ii] = 0.0;
    }

}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.
*/
void MLP_NN_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case MLP_NN_INIT_TYPE:
		INIT((MLP_NN_INIT *)commandInData);
		break;

	case MLP_NN_HALT_TYPE:
		HALT((MLP_NN_HALT *)commandInData);
		break;

	case MLP_NN_RUN_TYPE:
		RUN((MLP_NN_RUN *)commandInData);
		break;

	case MLP_NN_SET_ACTVATION_FUNCTION_TYPE_TYPE:
		SET_ACTVATION_FUNCTION_TYPE((MLP_NN_SET_ACTVATION_FUNCTION_TYPE *)commandInData);
		break;

	case MLP_NN_SET_ADAPTATION_GAIN_TYPE:
		SET_ADAPTATION_GAIN((MLP_NN_SET_ADAPTATION_GAIN *)commandInData);
		break;

	case MLP_NN_SET_INPUT_BIASES_TYPE:
		SET_INPUT_BIASES((MLP_NN_SET_INPUT_BIASES *)commandInData);
		break;

	case MLP_NN_SET_INPUT_WEIGHTS_TYPE:
		SET_INPUT_WEIGHTS((MLP_NN_SET_INPUT_WEIGHTS *)commandInData);
		break;

	case MLP_NN_SET_OUTPUT_BIASES_TYPE:
		SET_OUTPUT_BIASES((MLP_NN_SET_OUTPUT_BIASES *)commandInData);
		break;

	case MLP_NN_SET_OUTPUT_WEIGHTS_TYPE:
		SET_OUTPUT_WEIGHTS((MLP_NN_SET_OUTPUT_WEIGHTS *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.
*/
void MLP_NN_MODULE::POST_PROCESS()
{
	// Post-Processing Code

  // Report the current system inputs
  memcpy(mlp_nn_status->sys_inputs, sys_inputs, 
         num_of_inputs*sizeof(double));

  // Report the current system outputs
  memcpy(mlp_nn_status->sys_outputs, sys_outputs, 
         num_of_outputs*sizeof(double));

  // Report the current output errors
  memcpy(mlp_nn_status->output_errors, output_errors, 
         num_of_outputs*sizeof(double));

  // Report the current adaptation gain used
  mlp_nn_status->adaptation_gain = mlp->get_eta();

  // Report the current activation function type used
  mlp_nn_status->activation_function_type = 
    mlp->get_activation_function_type();

}

// Command Functions

/*
INIT

Parameter(s):
MLP_NN_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void MLP_NN_MODULE::INIT(MLP_NN_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
MLP_NN_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void MLP_NN_MODULE::HALT(MLP_NN_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
RUN

Parameter(s):
MLP_NN_RUN *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::RUN(MLP_NN_RUN *cmd_in)
{
	// Put state table for MLP_NN_RUN here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Calculate the system output
      mlp->control(sys_inputs, sys_outputs);

      // Update output parameters if necessary
      // Should read the error from PRE_PROCESS function
      //      mlp->update_output_params(output_error);
      //      mlp->bound_output_weights(low_val1, high_val1);
      //      mlp->bound_output_biases(low_val2, high_val2);

    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_ACTVATION_FUNCTION_TYPE

Parameter(s):
MLP_NN_SET_ACTVATION_FUNCTION_TYPE *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_ACTVATION_FUNCTION_TYPE(MLP_NN_SET_ACTVATION_FUNCTION_TYPE *cmd_in)
{
	// Put state table for MLP_NN_SET_ACTVATION_FUNCTION_TYPE here.
        if(STATE_MATCH(NEW_COMMAND))
        {
                status = RCS_EXEC;
                stateNext(S1);
        }
        else if(STATE_MATCH(S1))
        {
                mlp->set_activation_function_type(cmd_in->activation_function_type);

                status = RCS_DONE;
                stateNext(S2);
        }
        else if(STATE_MATCH(S2))
        {
                // Idle State
        }
}

/*
SET_ADAPTATION_GAIN

Parameter(s):
MLP_NN_SET_ADAPTATION_GAIN *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_ADAPTATION_GAIN(MLP_NN_SET_ADAPTATION_GAIN *cmd_in)
{
	// Put state table for MLP_NN_SET_ADAPTATION_GAIN here.
        if(STATE_MATCH(NEW_COMMAND))
        {
                status = RCS_EXEC;
                stateNext(S1);
        }
        else if(STATE_MATCH(S1))
        {
                mlp->set_eta(cmd_in->eta);

                status = RCS_DONE;
                stateNext(S2);
        }
        else if(STATE_MATCH(S2))
        {
                // Idle State
        }
}

/*
SET_INPUT_BIASES

Parameter(s):
MLP_NN_SET_INPUT_BIASES *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_INPUT_BIASES(MLP_NN_SET_INPUT_BIASES *cmd_in)
{
	// Put state table for MLP_NN_SET_INPUT_BIASES here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp->set_input_biases(cmd_in->input_biases);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_INPUT_WEIGHTS

Parameter(s):
MLP_NN_SET_INPUT_WEIGHTS *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_INPUT_WEIGHTS(MLP_NN_SET_INPUT_WEIGHTS *cmd_in)
{
	// Put state table for MLP_NN_SET_INPUT_WEIGHTS here.
  int ii, jj;
  
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_neurons; ii++)
        {
          for (jj = 0; jj < num_of_inputs; jj++)
            {
              temp1[ii][jj] = cmd_in->input_weights[ii*num_of_inputs + jj];
            }
        }
      mlp->set_input_weights(temp1);
      
      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_OUTPUT_BIASES

Parameter(s):
MLP_NN_SET_OUTPUT_BIASES *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_OUTPUT_BIASES(MLP_NN_SET_OUTPUT_BIASES *cmd_in)
{
	// Put state table for MLP_NN_SET_OUTPUT_BIASES here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp->set_output_biases(cmd_in->output_biases);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_OUTPUT_WEIGHTS

Parameter(s):
MLP_NN_SET_OUTPUT_WEIGHTS *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_MODULE::SET_OUTPUT_WEIGHTS(MLP_NN_SET_OUTPUT_WEIGHTS *cmd_in)
{
	// Put state table for MLP_NN_SET_OUTPUT_WEIGHTS here.
  int ii, jj;
  
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      for (ii = 0; ii < num_of_outputs; ii++)
        {
          for (jj = 0; jj < num_of_neurons; jj++)
            {
              temp2[ii][jj] = cmd_in->output_weights[ii*num_of_neurons + jj];
            }
        }
      mlp->set_output_weights(temp2);
      
      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

