/*
mlp_nn.hh

This C++ header file defines the class MLP_NN_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Thu Dec 21 12:37:02 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef MLP_NN_HH
#define MLP_NN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "mlp.hh" // MLP definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "mlp_nnn.hh" 	// NML Commands and Status definitions for mlp_nn
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class MLP_NN_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	MLP_NN_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(MLP_NN_INIT *);
	virtual void HALT(MLP_NN_HALT *);
	virtual void RUN(MLP_NN_RUN *);
	virtual void SET_ACTVATION_FUNCTION_TYPE(MLP_NN_SET_ACTVATION_FUNCTION_TYPE *);
	virtual void SET_ADAPTATION_GAIN(MLP_NN_SET_ADAPTATION_GAIN *);
	virtual void SET_INPUT_BIASES(MLP_NN_SET_INPUT_BIASES *);
	virtual void SET_INPUT_WEIGHTS(MLP_NN_SET_INPUT_WEIGHTS *);
	virtual void SET_OUTPUT_BIASES(MLP_NN_SET_OUTPUT_BIASES *);
	virtual void SET_OUTPUT_WEIGHTS(MLP_NN_SET_OUTPUT_WEIGHTS *);

	// Convenience Variables
	MLP_NN_STATUS *mlp_nn_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_of_inputs;
  int num_of_outputs;
  int num_of_neurons;

  MLP *mlp;

  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  double **temp1;
  double **temp2;

};

#endif 	// MLP_NN_HH

